﻿local Crayon = AceLibrary("LibCrayon-3.0")
local L = AceLibrary("AceLocale-2.2"):new("Dailies")

local format, len = _G.string.format, _G.string.len;
local gsub, trim = _G.string.gsub, _G.strtrim;
local DAILIES_TEXTURE_FORMAT= " " .. "|T%s:0:0:0:0|t\032"

DQT_USERS_ICON = format(DAILIES_TEXTURE_FORMAT, "Interface\\Icons\\INV_Misc_GroupNeedMore")
SILVER_ICON = format(DAILIES_TEXTURE_FORMAT, "Interface\\Addons\\DailiesQuestTracker\\Icons\\SilverIcon.tga")
COPPER_ICON = format(DAILIES_TEXTURE_FORMAT, "Interface\\Addons\\DailiesQuestTracker\\Icons\\CopperIcon.tga")
GOLD_ICON = format(DAILIES_TEXTURE_FORMAT, "Interface\\Addons\\DailiesQuestTracker\\Icons\\GoldIcon.tga")
COMM_ON_ICON = format(DAILIES_TEXTURE_FORMAT, "Interface\\Addons\\DailiesQuestTracker\\Icons\\CommOn.tga")

Dailies.newsCurrent = 1; -- Can only ever increase
WEB_URL = "http://www [dot] wowace [dot] com/forums/index [dot] php?topic=9356 [dot] 0"

function Dailies:News(override)
	if (not override and ((Dailies.db.profile.newsItem or 0) >= Dailies.newsCurrent)) then return; end
	self:CreateNewsFrame();
	
	self.newsFrame:Clear();
	self.newsFrame.title:SetText("|cffffd200"..L["Dailies Quest Tracker™"].."|r");
	self.newsFrame.disclaimer:SetText("Version: 2.4.2.07");
	
	-------- max length for "subject    ","body"------------------------------------------------------------------
	self.newsFrame:AddLine(L["Disclaimer	"],Crayon:Red(L["Reputation and rewards are based on a level 70 character."]));
	self.newsFrame:AddLine("            ","");
	self.newsFrame:AddLine(L["Description	"],L["Dailies Quest Tracker (DQT) is an addon that helps you keep track of the"]);
	self.newsFrame:AddLine("            ",L["dailies that you have done for the day. There is an optional part that"]);
	self.newsFrame:AddLine("            ",L["that lets you communicate the Random Dailies to other users, so they"]);
	self.newsFrame:AddLine("            ",L["don't need to visit a quest giver to know what they are. This is |cffff0000OFF|r by"]);
	self.newsFrame:AddLine("            ",L["default, and you must turn it on manually to use this feature."]);
	self.newsFrame:AddLine("            ","");

	-------- max length for "subject    ","body"--------------------------------------------------------------------
	self.newsFrame:AddLine(L["Updates     "],L["*) You can now display faction status and colorization in the group header"]);
	self.newsFrame:AddLine("		    ",L["of the DQT tooltip for easier reference, examples include:"]);
	self.newsFrame:AddLine("            ","");	
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Icon: ["] .. format(DAILIES_TEXTURE_FORMAT, "Interface\\PvPRankBadges\\PvPRank15") .. "]"));
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Title: ["]) .. Crayon:Purple(L["Exalted"]) .. Crayon:Gold("]"));
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Value: ["]) .. Crayon:Purple(L["Exalted"]) .. Crayon:Gold(": ") .. Crayon:Red("0") .. Crayon:Gold(L[" of "]) .. Crayon:Green("1000") .. Crayon:Gold("]"));
	self.newsFrame:AddLine("            ","");	
	self.newsFrame:AddLine("            ",L["*) You can move factions to inactive or collapse the group header"]);
	self.newsFrame:AddLine("		    ",L["in the reputation pane and DQT will still grab faction information"]);
	self.newsFrame:AddLine("		    ",L["correctly."]);
	self.newsFrame:AddLine("		    ",L["*) LibAbacus-3.0 is no longer used, as I'm formatting my own values."]);
	self.newsFrame:AddLine("		    ",L["*) Removed the below level 70 "] .. Crayon:Red(L["[DISCLAIMER]"]) .. L[" in the DQT tooltip,"]);
	self.newsFrame:AddLine("		    ",L["as it states it in other parts of the mod and frees space."]);
	self.newsFrame:AddLine("		    ",L["*) Removed the Random Dailies "] .. Crayon:Red(L["[MESSAGE]"]) .. L[" in the DQT tooltip,"]);
	self.newsFrame:AddLine("		    ",L["as it will automatically populate if you have the feature on."]);	
	self.newsFrame:AddLine("            ",L["*) All daily quests now have there own "] .. Crayon:Green("[Quest Link]") .. L[". You can insert this"]);
	self.newsFrame:AddLine("		    ",L["link into the chat frame by "] .. Crayon:Green(L["Shift-Left-Clicking"]) .. L[" a quest title from DQT."]);
	self.newsFrame:AddLine("            ",L["*) Many new things are formatted with icons, to make things more uniform"]);
	self.newsFrame:AddLine("            ",L["with the Blizzard interface, examples include:"]);
	self.newsFrame:AddLine("            ","");	
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Communications: "]) .. COMM_ON_ICON);
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Monetary Values: "]) .. Crayon:Gold(L["Gold"]) .. GOLD_ICON .. Crayon:Silver(L["Silver"]) .. SILVER_ICON .. Crayon:Copper(L["Copper"]) .. COPPER_ICON);
	self.newsFrame:AddLine("		    ","*) " .. Crayon:Gold(L["Dailies Quest Tracker Users: "]) .. DQT_USERS_ICON);
	self.newsFrame:AddLine("            ","");	
	-------- max length for "subject    ","body"---------------------------------------------------	
	self.newsFrame:AddLine(L["Command"],	format(L["'/%s %s' or '/%s %s'"], "DQT", "", "Dailies", ""));
	self.newsFrame:AddLine(L["Website"],	self:SpamSafe("|cff007fff" .. WEB_URL .. "|r"));
--	self.newsFrame:AddLine("E-mail",		self:SpamSafe("__EMAIL__"));
	self.newsFrame:AddLine("			","");
	self.newsFrame:AddLine(L["Thanks		"],"*) Leion/Tristan of Frostmane");
	self.newsFrame:AddLine("			","*) Chingerayl of Zul'Jin");
	self.newsFrame:AddLine("			","*) OrionShock of WowAce Community");
	self.newsFrame:AddLine("			","");
	self.newsFrame:AddLine("Fritos		",L["Hope you enjoy Dailies Quest Tracker!"]);
	
	-- do return; end
	self.newsFrame:Show();
	self.db.profile.newsItem = self.newsCurrent;
end

function Dailies:SpamSafe(text)
	-- replace ' [dot] ' with '.' and ' [at] ' with '@'
	return gsub(gsub(text, " %[at%] ", "@"), " %[dot%] ", ".");
end

function Dailies:CreateNewsFrame()
	Dailies.newsFrame = CreateFrame("Frame", "DailiesNewsFrame", UIParent, "DialogBoxFrame")
	Dailies.newsFrame:SetWidth(500)
	Dailies.newsFrame:SetHeight(400)
	Dailies.newsFrame:SetPoint("CENTER")
	Dailies.newsFrame:SetBackdrop({
		bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	    edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	    tile = true, tileSize = 16, edgeSize = 16,
	    insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
	Dailies.newsFrame:SetBackdropColor(0,0,0,1)

	local text = Dailies.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLarge")
	text:SetFont(L["Fonts\\SKURRI.TTF"], 24, "OUTLINE"); -- http://wdnaddons.com/2307561/FrameXML/Fonts.xml
	Dailies.newsFrame.title = text
	text:SetPoint("TOP", 0, -12)

	Dailies.newsFrame:Hide()

	Dailies.newsFrame.lefts = {}
	Dailies.newsFrame.rights = {}
	Dailies.newsFrame.textLefts = {}
	Dailies.newsFrame.textRights = {}
	function Dailies.newsFrame:Clear()
		self.title:SetText("")
		self.disclaimer:SetText("")
		for i = 1, #self.lefts do
			self.lefts[i] = nil
			self.rights[i] = nil
		end
	end
	
	local function rightColor(right)
		-- Email color as link
		right = gsub(right, "[A-Za-z0-9%.%%%+%-]+@[A-Za-z0-9%.%%%+%-]+%.%w%w%w?%w?", function(v) return "|cff007fff"..v.."|r"; end)
		
		-- '-quoted color gray
		right = gsub(right, "(%')(%/%w-%s?%w-)(%')", function(v1, v2, v3) return v1.."|cff00ff00"..v2.."|r"..v3; end) --00ff7f
		
		-- *) list with bullets
		right = gsub(right, "^(%*%)%s)(.+)", function(v1, v2) return Crayon:Gold("• ") .. v2; end)
		
		-- return the mess
		return right;
	end

	function Dailies.newsFrame:AddLine(left, right)
		Dailies.newsFrame.lefts[#Dailies.newsFrame.lefts+1] = trim(left);
		Dailies.newsFrame.rights[#Dailies.newsFrame.rights+1] = rightColor(trim(right));
	end

	local newsFrame_Show = Dailies.newsFrame.Show
	function Dailies.newsFrame:Show(...)
		local maxLeftWidth = 0
		local maxRightWidth = 0
		local textHeight = 0
		for i = 1, #self.lefts do
			if not self.textLefts[i] then
				local left = Dailies.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				left:SetFont(L["Fonts\\ARIALN.TTF"], 12);
				self.textLefts[i] = left
				local right = Dailies.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
				right:SetFont(L["Fonts\\ARIALN.TTF"], 12);
				self.textRights[i] = right
				if i == 1 then
					left:SetPoint("TOPRIGHT", Dailies.newsFrame, "TOPLEFT", 75, -35)
				else
					left:SetPoint("TOPRIGHT", self.textLefts[i-1], "BOTTOMRIGHT", 0, -1)
				end
				right:SetPoint("LEFT", left, "RIGHT", 5, 0)
			end
			self.textLefts[i]:SetText(self.lefts[i] .. ((len(self.lefts[i]) > 0 and len(strtrim(self.lefts[i])) > 0 and ":") or " "))
			self.textRights[i]:SetText(self.rights[i])
			local leftWidth = self.textLefts[i]:GetWidth()
			local rightWidth = self.textRights[i]:GetWidth()
			textHeight = self.textLefts[i]:GetHeight()
			if maxLeftWidth < leftWidth then
				maxLeftWidth = leftWidth
			end
			if maxRightWidth < rightWidth then
				maxRightWidth = rightWidth
			end
		end
		for i = #self.lefts+1, #self.textLefts do
			self.textLefts[i]:SetText('')
			self.textRights[i]:SetText('')
		end
		local finalWidth = 85 + maxRightWidth + 10;-- + 10 + 30;
		if (finalWidth < 360) then finalWidth = 360; end
		Dailies.newsFrame:SetWidth(finalWidth)
		Dailies.newsFrame:SetHeight(#self.lefts * (textHeight + 1) + 100)

		newsFrame_Show(self, ...)
	end
	Dailies.newsFrame:Hide()
	
	local disclaimer = Dailies.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	disclaimer:SetFont(L["Fonts\\ARIALN.TTF"], 8, "");
	Dailies.newsFrame.disclaimer = disclaimer
	disclaimer:SetPoint("BOTTOMRIGHT", Dailies.newsFrame:GetName(), "BOTTOMRIGHT", -5, 5)
	
	Dailies.CreateNewsFrame = function() return; end;
end